#!/usr/bin/env python
#coding=utf-8

import httplib,urllib
import hashlib
from datetime import datetime
import time

#商户会员的基本信息定义，这些信息可以从飞印平台的技术支持人员处获取
MEMBER_CODE = '7'
FEYIN_KEY = 'b06ae5c9'
FEYIN_HOST = '127.0.0.1'
FEYIN_PORT = 8000
FEYIN_KEEP_ALIVE = False

#提交格式化的内容
def sendFormatedMessage (msgInfo):
	reqTime = long(1000*time.time())
	md5 = hashlib.md5()
	content = '%s%s%s%s%s%s%s%s%s%s'%(msgInfo['memberCode'],msgInfo['customerName'],msgInfo['customerPhone'],msgInfo['customerAddress'],msgInfo['customerMemo'],msgInfo['msgDetail'],msgInfo['deviceNo'],msgInfo['msgNo'],reqTime,FEYIN_KEY)
	md5.update(content)
	msgInfo['reqTime'] = reqTime
	msgInfo['securityCode'] = md5.hexdigest()
	msgInfo['mode'] = 1
	sendContent = urllib.urlencode(msgInfo)	
	
	return sendPostMessage(sendContent)

#提交自由格式的内容
def sendFreeMessage(msgInfo):
	reqTime = long(1000*time.time())
	md5 = hashlib.md5()
	content = '%s%s%s%s%s%s'%(msgInfo['memberCode'],msgInfo['msgDetail'],msgInfo['deviceNo'],msgInfo['msgNo'],reqTime,FEYIN_KEY)
	md5.update(content)
	msgInfo['reqTime'] = reqTime
	msgInfo['securityCode'] = md5.hexdigest()
	msgInfo['mode'] = 2
	sendContent = urllib.urlencode(msgInfo)

	return sendPostMessage(sendContent)

#公用的Post提交方法
def sendPostMessage (sendContent):
	#定义文件头  
	headers = {"Content-Type":"application/x-www-form-urlencoded"}
	if FEYIN_KEEP_ALIVE:
		headers["Connection"] = "Keep-Alive"	
	conn = httplib.HTTPConnection(FEYIN_HOST,FEYIN_PORT)
	#开始进行数据提交
	conn.request(method="POST",url="/api/sendMsg",body=sendContent,headers=headers)
	#返回处理后的数据  
	response = conn.getresponse()
	#判断是否提交成功  
	if response.status == 302 or response.status == 200:
		msg = response.read()  
	else:  
		msg = "fail"
		print response.read()
	conn.close()
	return msg

#公用的Get提交方法
def sendGetMessage (url):
	#定义文件头  
	#headers = {"Content-Type":"application/x-www-form-urlencoded"}
	headers = {}
	if FEYIN_KEEP_ALIVE:
		headers["Connection"] = "Keep-Alive"	
	conn = httplib.HTTPConnection(FEYIN_HOST,FEYIN_PORT)
	#开始进行数据提交
	conn.request(method="GET",url=url)
	#返回处理后的数据  
	response = conn.getresponse()
	#判断是否提交成功  
	if response.status == 302 or response.status == 200:
		msg = response.read()  
	else:  
		msg = "fail"
		print response.read()
	conn.close()
	return msg
	
#查询打印状态
def queryState (msgNo):
	reqTime = long(1000*time.time())
	md5 = hashlib.md5()
	content = '%s%s%s%s'%(MEMBER_CODE,reqTime,FEYIN_KEY,msgNo)
	md5.update(content)

	params = {'memberCode':MEMBER_CODE,'securityCode':md5.hexdigest(),'reqTime':reqTime,'msgNo':msgNo}
	url = "/api/queryState?memberCode=%s&securityCode=%s&reqTime=%d&msgNo=%s"%(MEMBER_CODE,params['securityCode'],reqTime,msgNo)

	return sendGetMessage(url)

#查询设备列表
def listDevice ():
	reqTime = long(1000*time.time())
	md5 = hashlib.md5()
	content = '%s%s%s'%(MEMBER_CODE,reqTime,FEYIN_KEY)
	md5.update(content)

	params = {'memberCode':MEMBER_CODE,'securityCode':md5.hexdigest(),'reqTime':reqTime}
	url = "/api/listDevice?memberCode=%s&securityCode=%s&reqTime=%d"%(MEMBER_CODE,params['securityCode'],reqTime)
	
	return sendGetMessage(url)

#查询异常打印列表
def listException ():
	reqTime = long(1000*time.time())
	md5 = hashlib.md5()
	content = '%s%s%s'%(MEMBER_CODE,reqTime,FEYIN_KEY)
	md5.update(content)

	params = {'memberCode':MEMBER_CODE,'securityCode':md5.hexdigest(),'reqTime':reqTime}
	sendContent = urllib.urlencode(params)

	url="/api/listException?memberCode=%s&securityCode=%s&reqTime=%d"%(MEMBER_CODE,params['securityCode'],reqTime)

	
	return sendGetMessage(url)
	
#---------------api测试------------------
#测试发送格式化的消息
def testSendFormatedMsg ():
	msgNo = datetime.now().strftime('%Y%m%d%I%M%S')+MEMBER_CODE
	#定义消息的详细数据，注意，凡是有中文的地方，需要转成utf8编码
	msgInfo = {
		'memberCode':MEMBER_CODE,  
		'charge':'3000',  
		'customerName':u'刘小姐'.encode('utf-8'),  
		'customerPhone':'13321332245',  
		'customerAddress':u'五山华南理工'.encode('utf-8'),  
		'customerMemo':u'请快点送货'.encode('utf-8'),  
		'msgDetail':u'番茄炒粉@1000@1||客家咸香鸡@2000@1'.encode('utf-8'),  
		'deviceNo':'460000000646394',  
		'msgNo':msgNo
	}

	returnVal = sendFormatedMessage(msgInfo)

	print u'服务器返回:%s' % returnVal
	return msgNo

#测试发送自由格式的消息
def testSendFreeMessage ():
	msgNo = datetime.now().strftime('%Y%m%d%I%M%S')+'0'+MEMBER_CODE
	#定义消息的详细数据，注意，凡是有中文的地方，需要转成utf8编码
	freeMsgInfo = {
		'memberCode':MEMBER_CODE,  
		'msgDetail':u'这里是打印的内容，每次发送控制在262字内'.encode('utf-8'),  
		'deviceNo':'460000000646394',  
		'msgNo':msgNo
	}

	returnVal = sendFreeMessage(freeMsgInfo)

	print u'服务器返回:%s' % returnVal
	return msgNo

#测试获取设备列表
def testListDevice ():
	deviceListStr = listDevice()
	print u'服务器返回：'
	print deviceListStr
	
#测试获取异常消息列表
def testListException ():
	deviceListStr = listException()
	print u'服务器返回：'
	print deviceListStr



#测试获取设备列表
def testQueryState (msgNo):
	stateStr = queryState(msgNo)
	print u'服务器返回：'
	print stateStr

if __name__ == '__main__':

	#---------------------测试发送格式化的打印消息-----------------
	msgNo = testSendFormatedMsg()

	#---------------------测试发送自由格式的打印消息-----------------
	#msgNo = testSendFreeMessage()

	#---------------------测试查询设备列表----------------------------
	#testListDevice()

	#---------------------测试查询异常消息列表----------------------------
	#testListException()

	#---------------------测试查询打印状态----------------------------
	time.sleep(2)
	testQueryState(msgNo)
